diff --git a/base/server/src/engine/pkihelper.py b/base/server/src/engine/pkihelper.py
index e7735d8d37260d564d148842672bc31e6b42c638..df36583079cea16a0d199de3e0007bc7a1a12e12 100644
--- a/base/server/src/engine/pkihelper.py
+++ b/base/server/src/engine/pkihelper.py
@@ -2286,40 +2323,41 @@ class certutil:
                     pki_cert_database,
                     pki_key_database,
                     pki_secmod_database,
-                    extra=config.PKI_INDENTATION_LEVEL_2)
-                sys.exit(1)
+                    extra = config.PKI_INDENTATION_LEVEL_2)
+                raise Exception(log.PKI_SECURITY_DATABASES_DO_NOT_EXIST_3 % (pki_cert_database,
+                                                                             pki_key_database, pki_secmod_database))
             if not os.path.exists(noise_file):
                 config.pki_log.error(
                     log.PKI_DIRECTORY_MISSING_OR_NOT_A_DIRECTORY_1,
                     noise_file,
-                    extra=config.PKI_INDENTATION_LEVEL_2)
-                sys.exit(1)
+                    extra = config.PKI_INDENTATION_LEVEL_2)
+                raise Exception(log.PKI_DIRECTORY_MISSING_OR_NOT_A_DIRECTORY_1 % noise_file)
             if password_file != None:
                 if not os.path.exists(password_file) or\
                    not os.path.isfile(password_file):
                     config.pki_log.error(
                         log.PKI_FILE_MISSING_OR_NOT_A_FILE_1,
                         password_file,
-                        extra=config.PKI_INDENTATION_LEVEL_2)
-                    sys.exit(1)
+                        extra = config.PKI_INDENTATION_LEVEL_2)
+                    raise Exception(log.PKI_FILE_MISSING_OR_NOT_A_FILE_1 % password_file)
             # Execute this "certutil" command
-            subprocess.call(command, shell=True)
+            subprocess.call(command, shell = True)
         except subprocess.CalledProcessError as exc:
             config.pki_log.error(log.PKI_SUBPROCESS_ERROR_1, exc,
-                                 extra=config.PKI_INDENTATION_LEVEL_2)
+                                 extra = config.PKI_INDENTATION_LEVEL_2)
             if critical_failure == True:
                 raise
         except OSError as exc:
             config.pki_log.error(log.PKI_OSERROR_1, exc,
-                                 extra=config.PKI_INDENTATION_LEVEL_2)
+                                 extra = config.PKI_INDENTATION_LEVEL_2)
             if critical_failure == True:
                 raise
         return
 
     def import_cert(self, nickname, trust, input_file, password_file,
-                    path=None, token=None, critical_failure=True):
+                    path = None, token = None, critical_failure = True):
         try:
-            command = ["certutil","-A"]
+            command = ["certutil", "-A"]
             if path:
                 command.extend(["-d", path])
 
@@ -2331,44 +2369,44 @@ class certutil:
             else:
                 config.pki_log.error(
                     log.PKIHELPER_CERTUTIL_MISSING_NICKNAME,
-                    extra=config.PKI_INDENTATION_LEVEL_2)
-                sys.exit(1)
+                    extra = config.PKI_INDENTATION_LEVEL_2)
+                raise Exception(log.PKIHELPER_CERTUTIL_MISSING_NICKNAME)
 
             if trust:
                 command.extend(["-t", trust])
             else:
                 config.pki_log.error(
                     log.PKIHELPER_CERTUTIL_MISSING_TRUSTARGS,
-                    extra=config.PKI_INDENTATION_LEVEL_2)
-                sys.exit(1)
+                    extra = config.PKI_INDENTATION_LEVEL_2)
+                raise Exception(log.PKIHELPER_CERTUTIL_MISSING_TRUSTARGS)
 
             if input_file:
                 command.extend(["-i", input_file])
             else:
                 config.pki_log.error(
                     log.PKIHELPER_CERTUTIL_MISSING_INPUT_FILE,
-                    extra=config.PKI_INDENTATION_LEVEL_2)
-                sys.exit(1)
+                    extra = config.PKI_INDENTATION_LEVEL_2)
+                raise Exception(log.PKIHELPER_CERTUTIL_MISSING_INPUT_FILE)
 
             if password_file:
                 command.extend(["-f", password_file])
             else:
                 config.pki_log.error(
                     log.PKIHELPER_CERTUTIL_MISSING_PASSWORD_FILE,
-                    extra=config.PKI_INDENTATION_LEVEL_2)
-                sys.exit(1)
+                    extra = config.PKI_INDENTATION_LEVEL_2)
+                raise Exception(log.PKIHELPER_CERTUTIL_MISSING_PASSWORD_FILE)
 
             config.pki_log.info(command,
-                extra=config.PKI_INDENTATION_LEVEL_2)
+                extra = config.PKI_INDENTATION_LEVEL_2)
             subprocess.call(command)
         except subprocess.CalledProcessError as exc:
             config.pki_log.error(log.PKI_SUBPROCESS_ERROR_1, exc,
-                                 extra=config.PKI_INDENTATION_LEVEL_2)
+                                 extra = config.PKI_INDENTATION_LEVEL_2)
             if critical_failure == True:
                 raise
         except OSError as exc:
             config.pki_log.error(log.PKI_OSERROR_1, exc,
-                                 extra=config.PKI_INDENTATION_LEVEL_2)
+                                 extra = config.PKI_INDENTATION_LEVEL_2)
             if critical_failure == True:
                 raise
         return
@@ -2377,7 +2415,7 @@ class certutil:
                                      password_file, noise_file,
                                      output_file = None, path = None,
                                      ascii_format = None, token = None,
-                                     critical_failure=True):
+                                     critical_failure = True):
         try:
             command = ["certutil", "-R"]
             if path:
@@ -2393,8 +2431,8 @@ class certutil:
             else:
                 config.pki_log.error(
                     log.PKIHELPER_CERTUTIL_MISSING_SUBJECT,
-                    extra=config.PKI_INDENTATION_LEVEL_2)
-                sys.exit(1)
+                    extra = config.PKI_INDENTATION_LEVEL_2)
+                raise Exception(log.PKIHELPER_CERTUTIL_MISSING_SUBJECT)
 
             if key_size:
                 command.extend(["-g", str(key_size)])
@@ -2404,16 +2442,16 @@ class certutil:
             else:
                 config.pki_log.error(
                     log.PKIHELPER_CERTUTIL_MISSING_NOISE_FILE,
-                    extra=config.PKI_INDENTATION_LEVEL_2)
-                sys.exit(1)
+                    extra = config.PKI_INDENTATION_LEVEL_2)
+                raise Exception(log.PKIHELPER_CERTUTIL_MISSING_NOISE_FILE)
 
             if password_file:
                 command.extend(["-f", password_file])
             else:
                 config.pki_log.error(
                     log.PKIHELPER_CERTUTIL_MISSING_PASSWORD_FILE,
-                    extra=config.PKI_INDENTATION_LEVEL_2)
-                sys.exit(1)
+                    extra = config.PKI_INDENTATION_LEVEL_2)
+                raise Exception(log.PKIHELPER_CERTUTIL_MISSING_PASSWORD_FILE)
 
             if output_file:
                 command.extend(["-o", output_file])
@@ -2425,31 +2463,31 @@ class certutil:
             # Display this "certutil" command
             config.pki_log.info(
                 log.PKIHELPER_CERTUTIL_GENERATE_CSR_1, command,
-                extra=config.PKI_INDENTATION_LEVEL_2)
+                extra = config.PKI_INDENTATION_LEVEL_2)
             if not os.path.exists(noise_file):
                 config.pki_log.error(
                     log.PKI_DIRECTORY_MISSING_OR_NOT_A_DIRECTORY_1,
                     noise_file,
-                    extra=config.PKI_INDENTATION_LEVEL_2)
-                sys.exit(1)
+                    extra = config.PKI_INDENTATION_LEVEL_2)
+                raise Exception(log.PKI_DIRECTORY_MISSING_OR_NOT_A_DIRECTORY_1 % noise_file)
             if not os.path.exists(password_file) or\
                not os.path.isfile(password_file):
                 config.pki_log.error(
                     log.PKI_FILE_MISSING_OR_NOT_A_FILE_1,
                     password_file,
-                    extra=config.PKI_INDENTATION_LEVEL_2)
-                sys.exit(1)
+                    extra = config.PKI_INDENTATION_LEVEL_2)
+                raise Exception(log.PKI_FILE_MISSING_OR_NOT_A_FILE_1 % password_file)
             # Execute this "certutil" command
             with open(os.devnull, "w") as fnull:
-                subprocess.call(command, stdout=fnull, stderr=fnull)
+                subprocess.call(command, stdout = fnull, stderr = fnull)
         except subprocess.CalledProcessError as exc:
             config.pki_log.error(log.PKI_SUBPROCESS_ERROR_1, exc,
-                                 extra=config.PKI_INDENTATION_LEVEL_2)
+                                 extra = config.PKI_INDENTATION_LEVEL_2)
             if critical_failure == True:
                 raise
         except OSError as exc:
             config.pki_log.error(log.PKI_OSERROR_1, exc,
-                                 extra=config.PKI_INDENTATION_LEVEL_2)
+                                 extra = config.PKI_INDENTATION_LEVEL_2)
             if critical_failure == True:
                 raise
         return
@@ -2457,7 +2495,7 @@ class certutil:
 # pk12util class
 class pk12util:
     def create_file(self, out_file, nickname, out_pwfile,
-                    db_pwfile, path=None):
+                    db_pwfile, path = None):
         try:
             command = ["pk12util"]
             if path:
@@ -2467,42 +2505,42 @@ class pk12util:
             else:
                 config.pki_log.error(
                     log.PKIHELPER_PK12UTIL_MISSING_OUTFILE,
-                    extra=config.PKI_INDENTATION_LEVEL_2)
-                sys.exit(1)
+                    extra = config.PKI_INDENTATION_LEVEL_2)
+                raise Exception(log.PKIHELPER_PK12UTIL_MISSING_OUTFILE)
             if nickname:
                 command.extend(["-n", nickname])
             else:
                 config.pki_log.error(
                     log.PKIHELPER_PK12UTIL_MISSING_NICKNAME,
-                    extra=config.PKI_INDENTATION_LEVEL_2)
-                sys.exit(1)
+                    extra = config.PKI_INDENTATION_LEVEL_2)
+                raise Exception(log.PKIHELPER_PK12UTIL_MISSING_NICKNAME)
             if out_pwfile:
                 command.extend(["-w", out_pwfile])
             else:
                 config.pki_log.error(
                     log.PKIHELPER_PK12UTIL_MISSING_OUTPWFILE,
-                    extra=config.PKI_INDENTATION_LEVEL_2)
-                sys.exit(1)
+                    extra = config.PKI_INDENTATION_LEVEL_2)
+                raise Exception(log.PKIHELPER_PK12UTIL_MISSING_OUTPWFILE)
             if db_pwfile:
                 command.extend(["-k", db_pwfile])
             else:
                 config.pki_log.error(
                     log.PKIHELPER_PK12UTIL_MISSING_DBPWFILE,
-                    extra=config.PKI_INDENTATION_LEVEL_2)
-                sys.exit(1)
+                    extra = config.PKI_INDENTATION_LEVEL_2)
+                raise Exception(log.PKIHELPER_PK12UTIL_MISSING_DBPWFILE)
 
             config.pki_log.info(command,
-                    extra=config.PKI_INDENTATION_LEVEL_2)
+                    extra = config.PKI_INDENTATION_LEVEL_2)
             with open(os.devnull, "w") as fnull:
-                subprocess.call(command, stdout=fnull, stderr=fnull)
+                subprocess.call(command, stdout = fnull, stderr = fnull)
         except subprocess.CalledProcessError as exc:
             config.pki_log.error(log.PKI_SUBPROCESS_ERROR_1, exc,
-                                 extra=config.PKI_INDENTATION_LEVEL_2)
+                                 extra = config.PKI_INDENTATION_LEVEL_2)
             if critical_failure == True:
                 raise
         except OSError as exc:
             config.pki_log.error(log.PKI_OSERROR_1, exc,
-                                 extra=config.PKI_INDENTATION_LEVEL_2)
+                                 extra = config.PKI_INDENTATION_LEVEL_2)
             if critical_failure == True:
                 raise
         return
@@ -2510,7 +2548,7 @@ class pk12util:
 
 # KRA Connector Class
 class kra_connector:
-    def deregister(self, critical_failure=False):
+    def deregister(self, critical_failure = False):
         try:
             # this is applicable to KRAs only
             if master['pki_subsystem_type'] != "kra":
@@ -2518,7 +2556,7 @@ class kra_connector:
 
             config.pki_log.info(
                 log.PKIHELPER_KRACONNECTOR_UPDATE_CONTACT,
-                extra=config.PKI_INDENTATION_LEVEL_2)
+                extra = config.PKI_INDENTATION_LEVEL_2)
 
             cs_cfg = PKIConfigParser.read_simple_configuration_file(
                          master['pki_target_cs_cfg'])
@@ -2530,12 +2568,12 @@ class kra_connector:
                caport is None:
                 config.pki_log.warning(
                     log.PKIHELPER_KRACONNECTOR_UPDATE_FAILURE,
-                    extra=config.PKI_INDENTATION_LEVEL_2)
+                    extra = config.PKI_INDENTATION_LEVEL_2)
                 config.pki_log.error(
                     log.PKIHELPER_UNDEFINED_CA_HOST_PORT,
-                    extra=config.PKI_INDENTATION_LEVEL_2)
+                    extra = config.PKI_INDENTATION_LEVEL_2)
                 if critical_failure == True:
-                    sys.exit(-1)
+                    raise Exception(log.PKIHELPER_UNDEFINED_CA_HOST_PORT)
                 else:
                     return
 
@@ -2544,12 +2582,12 @@ class kra_connector:
             if subsystemnick is None:
                 config.pki_log.warning(
                     log.PKIHELPER_KRACONNECTOR_UPDATE_FAILURE,
-                    extra=config.PKI_INDENTATION_LEVEL_2)
+                    extra = config.PKI_INDENTATION_LEVEL_2)
                 config.pki_log.error(
                     log.PKIHELPER_UNDEFINED_SUBSYSTEM_NICKNAME,
-                    extra=config.PKI_INDENTATION_LEVEL_2)
+                    extra = config.PKI_INDENTATION_LEVEL_2)
                 if critical_failure == True:
-                    sys.exit(-1)
+                    raise Exception(log.PKIHELPER_UNDEFINED_SUBSYSTEM_NICKNAME)
                 else:
                     return
 
@@ -2567,13 +2605,13 @@ class kra_connector:
             if token_pwd is None or token_pwd == '':
                 config.pki_log.warning(
                     log.PKIHELPER_KRACONNECTOR_UPDATE_FAILURE,
-                    extra=config.PKI_INDENTATION_LEVEL_2)
+                    extra = config.PKI_INDENTATION_LEVEL_2)
                 config.pki_log.error(
                     log.PKIHELPER_UNDEFINED_TOKEN_PASSWD_1,
                     token_name,
-                    extra=config.PKI_INDENTATION_LEVEL_2)
+                    extra = config.PKI_INDENTATION_LEVEL_2)
                 if critical_failure == True:
-                    sys.exit(-1)
+                    raise Exception(log.PKIHELPER_UNDEFINED_TOKEN_PASSWD_1 % token_name)
                 else:
                     return
 
@@ -2585,15 +2623,15 @@ class kra_connector:
                 log.PKIHELPER_KRACONNECTOR_UPDATE_FAILURE_2,
                 str(krahost),
                 str(kraport),
-                extra=config.PKI_INDENTATION_LEVEL_2)
+                extra = config.PKI_INDENTATION_LEVEL_2)
             config.pki_log.error(log.PKI_SUBPROCESS_ERROR_1, exc,
-                                 extra=config.PKI_INDENTATION_LEVEL_2)
+                                 extra = config.PKI_INDENTATION_LEVEL_2)
             if critical_failure == True:
                 raise
         return
 
     def execute_using_pki(self, caport, cahost, subsystemnick,
-      token_pwd, krahost, kraport, critical_failure=False):
+      token_pwd, krahost, kraport, critical_failure = False):
         command = "/bin/pki -p '{}' -h '{}' -n '{}' -P https -d '{}' -c '{}' "\
                   "kraconnector-del {} {}".format(
                       caport, cahost, subsystemnick,
@@ -2601,8 +2639,8 @@ class kra_connector:
                       token_pwd, krahost, kraport)
 
         output = subprocess.check_output(command,
-                                         stderr=subprocess.STDOUT,
-                                         shell=True)
+                                         stderr = subprocess.STDOUT,
+                                         shell = True)
 
         error = re.findall("ClientResponseFailure:(.*?)", output)
         if error:
@@ -2610,18 +2648,18 @@ class kra_connector:
                 log.PKIHELPER_KRACONNECTOR_UPDATE_FAILURE_2,
                 str(krahost),
                 str(kraport),
-                extra=config.PKI_INDENTATION_LEVEL_2)
+                extra = config.PKI_INDENTATION_LEVEL_2)
             config.pki_log.error(log.PKI_SUBPROCESS_ERROR_1, output,
-                extra=config.PKI_INDENTATION_LEVEL_2)
+                extra = config.PKI_INDENTATION_LEVEL_2)
         if critical_failure == True:
-            sys.exit(-1)
+            raise Exception(log.PKI_SUBPROCESS_ERROR_1 % output)
 
     def execute_using_sslget(self, caport, cahost, subsystemnick,
       token_pwd, krahost, kraport):
         urlheader = "https://{}:{}".format(cahost, caport)
         updateURL = "/ca/rest/admin/kraconnector/remove"
 
-        params = "host=" + str(krahost) +\
+        params = "host=" + str(krahost) + \
                  "&port=" + str(kraport)
 
         command = "/usr/bin/sslget -n '{}' -p '{}' -d '{}' -e '{}' "\
@@ -2636,12 +2674,12 @@ class kra_connector:
         # Note that sslget will return non-zero value for HTTP code != 200
         # and this will raise an exception
         output = subprocess.check_output(command,
-                                         stderr=subprocess.STDOUT,
-                                         shell=True)
+                                         stderr = subprocess.STDOUT,
+                                         shell = True)
 
 # PKI Deployment Security Domain Class
 class security_domain:
-    def deregister(self, install_token, critical_failure=False):
+    def deregister(self, install_token, critical_failure = False):
         # process this PKI subsystem instance's 'CS.cfg'
         cs_cfg = PKIConfigParser.read_simple_configuration_file(
             master['pki_target_cs_cfg'])
@@ -2671,32 +2709,32 @@ class security_domain:
                 log.PKIHELPER_SECURITY_DOMAIN_UPDATE_FAILURE_2,
                 typeval,
                 secname,
-                extra=config.PKI_INDENTATION_LEVEL_2)
+                extra = config.PKI_INDENTATION_LEVEL_2)
             config.pki_log.error(
                 log.PKIHELPER_SECURITY_DOMAIN_UNDEFINED,
-                extra=config.PKI_INDENTATION_LEVEL_2)
+                extra = config.PKI_INDENTATION_LEVEL_2)
             if critical_failure == True:
-                sys.exit(-1)
+                raise Exception(log.PKIHELPER_SECURITY_DOMAIN_UNDEFINED)
             else:
                 return
 
         config.pki_log.info(log.PKIHELPER_SECURITY_DOMAIN_CONTACT_1,
                             secname,
-                            extra=config.PKI_INDENTATION_LEVEL_2)
+                            extra = config.PKI_INDENTATION_LEVEL_2)
         listval = typeval.lower() + "List"
         urlheader = "https://{}:{}".format(sechost, seceeport)
         urlagentheader = "https://{}:{}".format(sechost, secagentport)
         urladminheader = "https://{}:{}".format(sechost, secadminport)
         updateURL = "/ca/agent/ca/updateDomainXML"
 
-        params = "name=" + "\"" + master['pki_instance_path'] + "\"" +\
-                 "&type=" + str(typeval) +\
-                 "&list=" + str(listval) +\
-                 "&host=" + str(machinename) +\
-                 "&sport=" + str(sport) +\
-                 "&ncsport=" + str(ncsport) +\
-                 "&adminsport=" + str(adminsport) +\
-                 "&agentsport=" + str(agentsport) +\
+        params = "name=" + "\"" + master['pki_instance_path'] + "\"" + \
+                 "&type=" + str(typeval) + \
+                 "&list=" + str(listval) + \
+                 "&host=" + str(machinename) + \
+                 "&sport=" + str(sport) + \
+                 "&ncsport=" + str(ncsport) + \
+                 "&adminsport=" + str(adminsport) + \
+                 "&agentsport=" + str(agentsport) + \
                  "&operation=remove"
 
         if install_token:
@@ -2710,13 +2748,13 @@ class security_domain:
                              params, adminUpdateURL,
                              sechost, secadminport)
                 output = subprocess.check_output(command,
-                                             stderr=subprocess.STDOUT,
-                                             shell=True)
+                                             stderr = subprocess.STDOUT,
+                                             shell = True)
             except subprocess.CalledProcessError as exc:
                 config.pki_log.warning(
                     log.PKIHELPER_SECURITY_DOMAIN_UNREACHABLE_1,
                     secname,
-                    extra=config.PKI_INDENTATION_LEVEL_2)
+                    extra = config.PKI_INDENTATION_LEVEL_2)
                 output = self.update_domain_using_agent_port(typeval,
                     secname, params, updateURL, sechost, secagentport,
                     critical_failure)
@@ -2727,22 +2765,22 @@ class security_domain:
 
         if not output:
             if critical_failure == True:
-                sys.exit(-1)
+                raise Exception("Cannot update domain using agent port")
             else:
                 return
 
         config.pki_log.debug(log.PKIHELPER_SSLGET_OUTPUT_1,
                              output,
-                             extra=config.PKI_INDENTATION_LEVEL_2)
+                             extra = config.PKI_INDENTATION_LEVEL_2)
         # Search the output for Status
         status = re.findall("\<Status\>(.*?)\<\/Status\>", output)
         if not status:
             config.pki_log.warning(
                 log.PKIHELPER_SECURITY_DOMAIN_UNREACHABLE_1,
                 secname,
-                extra=config.PKI_INDENTATION_LEVEL_2)
+                extra = config.PKI_INDENTATION_LEVEL_2)
             if critical_failure == True:
-                sys.exit(-1)
+                raise Exception(log.PKIHELPER_SECURITY_DOMAIN_UNREACHABLE_1 % secname)
         elif status[0] != "0":
             error = re.findall("\<Error\>(.*?)\<\/Error\>", output)
             if not error:
@@ -2751,24 +2789,26 @@ class security_domain:
                 log.PKIHELPER_SECURITY_DOMAIN_UNREGISTERED_2,
                 typeval,
                 secname,
-                extra=config.PKI_INDENTATION_LEVEL_2)
+                extra = config.PKI_INDENTATION_LEVEL_2)
             config.pki_log.error(
                 log.PKIHELPER_SECURITY_DOMAIN_UPDATE_FAILURE_3,
                 typeval,
                 secname,
                 error,
-                extra=config.PKI_INDENTATION_LEVEL_2)
+                extra = config.PKI_INDENTATION_LEVEL_2)
             if critical_failure == True:
-                sys.exit(-1)
+                raise Exception(log.PKIHELPER_SECURITY_DOMAIN_UPDATE_FAILURE_3
+                                %
+                                (typeval, secname, error))
         else:
             config.pki_log.info(
                 log.PKIHELPER_SECURITY_DOMAIN_UPDATE_SUCCESS_2,
                 typeval,
                 secname,
-                extra=config.PKI_INDENTATION_LEVEL_2)
+                extra = config.PKI_INDENTATION_LEVEL_2)
 
     def update_domain_using_agent_port(self, typeval, secname, params,
-        updateURL, sechost, secagentport, critical_failure= False):
+        updateURL, sechost, secagentport, critical_failure = False):
         token_pwd = None
         cs_cfg = PKIConfigParser.read_simple_configuration_file(
             master['pki_target_cs_cfg'])
@@ -2780,12 +2820,12 @@ class security_domain:
                 log.PKIHELPER_SECURITY_DOMAIN_UPDATE_FAILURE_2,
                 typeval,
                 secname,
-                extra=config.PKI_INDENTATION_LEVEL_2)
+                extra = config.PKI_INDENTATION_LEVEL_2)
             config.pki_log.error(
                 log.PKIHELPER_UNDEFINED_SUBSYSTEM_NICKNAME,
-                extra=config.PKI_INDENTATION_LEVEL_2)
+                extra = config.PKI_INDENTATION_LEVEL_2)
             if critical_failure == True:
-                sys.exit(-1)
+                raise Exception(log.PKIHELPER_UNDEFINED_SUBSYSTEM_NICKNAME)
             else:
                 return
 
@@ -2805,9 +2845,11 @@ class security_domain:
                 log.PKIHELPER_SECURITY_DOMAIN_UPDATE_FAILURE_2,
                 typeval,
                 secname,
-                extra=config.PKI_INDENTATION_LEVEL_2)
+                extra = config.PKI_INDENTATION_LEVEL_2)
             if critical_failure == True:
-                sys.exit(-1)
+                raise Exception(log.PKIHELPER_SECURITY_DOMAIN_UPDATE_FAILURE_2
+                                %
+                                (typeval, secname))
             else:
                 return
 
@@ -2819,28 +2861,28 @@ class security_domain:
                       sechost, secagentport)
         try:
             output = subprocess.check_output(command,
-                                             stderr=subprocess.STDOUT,
-                                             shell=True)
+                                             stderr = subprocess.STDOUT,
+                                             shell = True)
             return output
         except subprocess.CalledProcessError as exc:
             config.pki_log.warning(
                 log.PKIHELPER_SECURITY_DOMAIN_UPDATE_FAILURE_2,
                 typeval,
                 secname,
-                extra=config.PKI_INDENTATION_LEVEL_2)
+                extra = config.PKI_INDENTATION_LEVEL_2)
             config.pki_log.warning(
                 log.PKIHELPER_SECURITY_DOMAIN_UNREACHABLE_1,
                 secname,
-                extra=config.PKI_INDENTATION_LEVEL_2)
+                extra = config.PKI_INDENTATION_LEVEL_2)
             config.pki_log.error(log.PKI_SUBPROCESS_ERROR_1, exc,
-                                 extra=config.PKI_INDENTATION_LEVEL_2)
+                                 extra = config.PKI_INDENTATION_LEVEL_2)
             if critical_failure == True:
                 raise
 
         return None
 
 
-    def get_installation_token(self, secuser, secpass, critical_failure=True):
+    def get_installation_token(self, secuser, secpass, critical_failure = True):
         token = None
 
         if not secuser or not secpass:
@@ -2865,8 +2907,8 @@ class security_domain:
                       machinename, cstype)
         try:
             output = subprocess.check_output(command,
-                                         stderr=subprocess.STDOUT,
-                                         shell=True)
+                                         stderr = subprocess.STDOUT,
+                                         shell = True)
 
             token_list = re.findall("Install token: \"(.*)\"", output)
             if not token_list:
@@ -2874,11 +2916,13 @@ class security_domain:
                     log.PKIHELPER_SECURITY_DOMAIN_GET_TOKEN_FAILURE_2,
                     str(sechost),
                     str(secadminport),
-                    extra=config.PKI_INDENTATION_LEVEL_2)
+                    extra = config.PKI_INDENTATION_LEVEL_2)
                 config.pki_log.error(log.PKI_SUBPROCESS_ERROR_1, output,
-                    extra=config.PKI_INDENTATION_LEVEL_2)
+                    extra = config.PKI_INDENTATION_LEVEL_2)
                 if critical_failure == True:
-                    sys.exit(-1)
+                    raise Exception(log.PKIHELPER_SECURITY_DOMAIN_GET_TOKEN_FAILURE_2
+                                    %
+                                    (str(sechost), str(secadminport)))
             else:
                 token = token_list[0]
                 return token
